"use strict";
// tslint:disable no-floating-promises
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var PouchDB = require("pouchdb");
var PouchDBAdapterMemory = require("pouchdb-adapter-memory");
var redux_mock_store_1 = require("redux-mock-store");
var sync = require("../index");
PouchDB.plugin(PouchDBAdapterMemory);
var kind = 'kind';
var db;
var remoteDb;
var store;
var models;
var now = new Date();
function lastAction() {
    var actions = store.getActions();
    return actions[actions.length - 1];
}
beforeEach(function (done) { return __awaiter(_this, void 0, void 0, function () {
    var replication, middlewares;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                models = [
                    { kind: kind, _id: '1234', value: 1234, createdAt: now, modifiedAt: now },
                    { kind: kind, _id: '2345', value: 2345, createdAt: now, modifiedAt: now },
                    { kind: kind, _id: '3456', value: 3456, createdAt: now, modifiedAt: now },
                ];
                db = new PouchDB('test', { adapter: 'memory' });
                remoteDb = new PouchDB('test-remote', { adapter: 'memory' });
                replication = db.sync(remoteDb, { live: true, retry: true });
                return [4 /*yield*/, db.bulkDocs(models)];
            case 1:
                _a.sent();
                middlewares = [sync.sync(db, replication, [kind], 'test', done)];
                store = redux_mock_store_1.default(middlewares)();
                return [2 /*return*/];
        }
    });
}); });
afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, db.destroy()];
            case 1:
                _a.sent();
                return [4 /*yield*/, remoteDb.destroy()];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
describe('initialization', function () {
    it('should dispatch initialized', function () {
        var actions = store.getActions();
        expect(actions.length).toBeGreaterThan(0);
        expect(actions).toContainEqual({
            meta: { name: 'test' },
            type: sync.INITIALIZED,
        });
    });
    it('should dispatch load_models', function () { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        var actions, storedModels;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    actions = store.getActions();
                    return [4 /*yield*/, Promise.all(models.map(function (m) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2 /*return*/, db.get(m._id)];
                        }); }); }))];
                case 1:
                    storedModels = _a.sent();
                    expect(actions.length).toBeGreaterThan(0);
                    expect(actions).toContainEqual({
                        type: sync.LOAD_MODELS,
                        meta: { kind: kind },
                        payload: storedModels,
                    });
                    expect(actions).toContainEqual({
                        type: sync.MODEL_INITIALIZED,
                        meta: { kind: kind },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should dispatch model_initialized', function () {
        var actions = store.getActions();
        expect(actions.length).toBeGreaterThan(0);
        expect(actions).toContainEqual({
            type: sync.MODEL_INITIALIZED,
            meta: { kind: kind },
        });
    });
});
describe('inserting', function () {
    it('should handle an insert action', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    store.clearActions();
                    store.dispatch(sync.insertModel(model));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc = _a.sent();
                    expect(doc).toMatchObject({ _id: model._id, value: 123 });
                    expect(store.getActions().length).toBe(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle duplicate an insert action', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc1, doc2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    store.dispatch(sync.insertModel(model));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc1 = _a.sent();
                    store.dispatch(sync.insertModel(__assign({}, model, doc1, { value: 234 })));
                    return [4 /*yield*/, db.get('0123')];
                case 2:
                    doc2 = _a.sent();
                    expect(doc2).toMatchObject({ _id: model._id, value: 234 });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle an bulk insert action', function () { return __awaiter(_this, void 0, void 0, function () {
        var modelsToInsert, doc1, doc2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    modelsToInsert = [
                        { kind: kind, _id: '0123', value: 123, createdAt: now, modifiedAt: now },
                        {
                            kind: kind,
                            _id: '1234',
                            value: 1234,
                            createdAt: now,
                            modifiedAt: now,
                        },
                    ];
                    store.dispatch(sync.insertBulkModels(modelsToInsert, kind));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc1 = _a.sent();
                    return [4 /*yield*/, db.get('1234')];
                case 2:
                    doc2 = _a.sent();
                    expect(doc1).toMatchObject({
                        kind: kind,
                        _id: '0123',
                        value: 123,
                    });
                    expect(doc2).toMatchObject({
                        kind: kind,
                        _id: '1234',
                        value: 1234,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('updating', function () {
    it('should handle an insert and update action', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc1, doc2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    store.dispatch(sync.insertModel(model));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc1 = _a.sent();
                    store.dispatch(sync.updateModel(__assign({}, model, doc1, { value: 234 })));
                    return [4 /*yield*/, db.get('0123')];
                case 2:
                    doc2 = _a.sent();
                    expect(doc2).toMatchObject({ _id: model._id, value: 234 });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle an update action without a previous insert', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    store.clearActions();
                    store.dispatch(sync.updateModel(model));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc = _a.sent();
                    expect(doc).toMatchObject({ _id: model._id, value: 123 });
                    expect(store.getActions().length).toBe(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle an bulk update action', function () { return __awaiter(_this, void 0, void 0, function () {
        var modelsToInsert, doc1_1, doc2_1, modelsToUpdate, doc1, doc2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    modelsToInsert = [
                        { kind: kind, _id: '0123', value: 123, createdAt: now, modifiedAt: now },
                        { kind: kind, _id: '1234', value: 1234, createdAt: now, modifiedAt: now },
                    ];
                    store.dispatch(sync.insertBulkModels(modelsToInsert, kind));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc1_1 = _a.sent();
                    return [4 /*yield*/, db.get('1234')];
                case 2:
                    doc2_1 = _a.sent();
                    modelsToUpdate = [
                        __assign({}, doc1_1, { kind: kind, value: 321, createdAt: now, modifiedAt: now }),
                        __assign({}, doc2_1, { kind: kind, value: 4321, createdAt: now, modifiedAt: now }),
                    ];
                    store.dispatch(sync.updateBulkModels(modelsToUpdate, kind));
                    return [4 /*yield*/, db.get('0123')];
                case 3:
                    doc1 = _a.sent();
                    return [4 /*yield*/, db.get('1234')];
                case 4:
                    doc2 = _a.sent();
                    expect(doc1).toMatchObject({ kind: kind, _id: '0123', value: 321 });
                    expect(doc2).toMatchObject({ kind: kind, _id: '1234', value: 4321 });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle an bulk update action without previous insert', function () { return __awaiter(_this, void 0, void 0, function () {
        var modelsToUpdate, doc1, doc2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    modelsToUpdate = [
                        { kind: kind, _id: '0123', value: 123, createdAt: now, modifiedAt: now },
                        { kind: kind, _id: '1234', value: 1234, createdAt: now, modifiedAt: now },
                    ];
                    store.dispatch(sync.updateBulkModels(modelsToUpdate, kind));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc1 = _a.sent();
                    return [4 /*yield*/, db.get('1234')];
                case 2:
                    doc2 = _a.sent();
                    expect(doc1).toMatchObject({ kind: kind, _id: '0123', value: 123 });
                    expect(doc2).toMatchObject({ kind: kind, _id: '1234', value: 1234 });
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('removing', function () {
    it('should handle an insert and remove action', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc1, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    store.dispatch(sync.insertModel(model));
                    return [4 /*yield*/, db.get('0123', { revs: true })];
                case 1:
                    doc1 = _a.sent();
                    store.dispatch(sync.removeModel({ _id: doc1._id, _rev: doc1._rev }, kind));
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, db.get('0123')];
                case 3:
                    _a.sent();
                    fail('Should not be able to retrieve a removed model');
                    return [3 /*break*/, 5];
                case 4:
                    err_1 = _a.sent();
                    expect(err_1).toMatchObject({
                        status: 404,
                        name: 'not_found',
                        message: 'missing',
                        error: true,
                        reason: 'deleted',
                    });
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    }); });
    it('should handle an remove action without a previous insert', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    store.clearActions();
                    store.dispatch(sync.removeModel({ _id: model._id, _rev: '' }, kind));
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, db.get('0123')];
                case 2:
                    _a.sent();
                    fail('Should not be able to retrieve a removed model');
                    return [3 /*break*/, 4];
                case 3:
                    err_2 = _a.sent();
                    expect(err_2).toMatchObject({
                        status: 404,
                        name: 'not_found',
                        message: 'missing',
                        error: true,
                        reason: 'missing',
                    });
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    it('should handle an bulk remove action', function () { return __awaiter(_this, void 0, void 0, function () {
        var modelsToInsert, doc1, doc2, modelsToRemove, err_3, err_4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    modelsToInsert = [
                        { kind: kind, _id: '0123', value: 123, createdAt: now, modifiedAt: now },
                        { kind: kind, _id: '1234', value: 1234, createdAt: now, modifiedAt: now },
                    ];
                    store.dispatch(sync.insertBulkModels(modelsToInsert, kind));
                    return [4 /*yield*/, db.get('0123')];
                case 1:
                    doc1 = _a.sent();
                    return [4 /*yield*/, db.get('1234')];
                case 2:
                    doc2 = _a.sent();
                    modelsToRemove = [
                        { _id: doc1._id, _rev: doc1._rev },
                        { _id: doc2._id, _rev: doc2._rev },
                    ];
                    store.dispatch(sync.removeBulkModels(modelsToRemove, kind));
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4 /*yield*/, db.get('0123')];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 5:
                    err_3 = _a.sent();
                    expect(err_3).toMatchObject({
                        status: 404,
                        name: 'not_found',
                        message: 'missing',
                        error: true,
                        reason: 'deleted',
                    });
                    return [3 /*break*/, 6];
                case 6:
                    _a.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, db.get('1234')];
                case 7:
                    _a.sent();
                    return [3 /*break*/, 9];
                case 8:
                    err_4 = _a.sent();
                    expect(err_4).toMatchObject({
                        status: 404,
                        name: 'not_found',
                        message: 'missing',
                        error: true,
                        reason: 'deleted',
                    });
                    return [3 /*break*/, 9];
                case 9: return [2 /*return*/];
            }
        });
    }); });
});
describe('syncing', function () {
    it('should handle an insert in the remote database', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc, actions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    store.clearActions();
                    model = {
                        kind: kind,
                        _id: '0123',
                        value: 123,
                        createdAt: now,
                        modifiedAt: now,
                    };
                    return [4 /*yield*/, remoteDb.put(model)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, db.sync(remoteDb)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, db.get('0123')];
                case 3:
                    doc = _a.sent();
                    actions = store.getActions();
                    expect(actions.length).toBeGreaterThan(0);
                    expect(actions).toContainEqual({
                        type: sync.INSERT_BULK_MODELS,
                        meta: { kind: kind, fromSync: true },
                        payload: [doc],
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle an insert and update in the remote database', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    store.clearActions();
                    model = { kind: kind, _id: '0123', value: 123 };
                    return [4 /*yield*/, remoteDb.put(model)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, db.sync(remoteDb)];
                case 2:
                    _a.sent();
                    store.clearActions();
                    return [4 /*yield*/, remoteDb.get('0123')];
                case 3:
                    doc = _a.sent();
                    return [4 /*yield*/, remoteDb.put({
                            _id: doc._id,
                            _rev: doc._rev,
                            kind: kind,
                            value: 234,
                        })];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, db.sync(remoteDb)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, db.get('0123')];
                case 6:
                    doc = _a.sent();
                    expect(lastAction()).toMatchObject({
                        type: sync.UPDATE_BULK_MODELS,
                        meta: { kind: kind, fromSync: true },
                        payload: [__assign({}, doc)],
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle an insert and remove in the remote database', function () { return __awaiter(_this, void 0, void 0, function () {
        var model, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    store.clearActions();
                    model = { kind: kind, _id: '0123', value: 123 };
                    return [4 /*yield*/, remoteDb.put(model)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, db.sync(remoteDb)];
                case 2:
                    _a.sent();
                    store.clearActions();
                    return [4 /*yield*/, remoteDb.get('0123')];
                case 3:
                    doc = _a.sent();
                    return [4 /*yield*/, remoteDb.put({
                            _id: doc._id,
                            _rev: doc._rev,
                            kind: kind,
                            value: 234,
                        })];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, db.sync(remoteDb)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, db.get('0123')];
                case 6:
                    doc = _a.sent();
                    expect(lastAction()).toMatchObject({
                        type: sync.UPDATE_BULK_MODELS,
                        meta: { kind: kind, fromSync: true },
                        payload: [__assign({}, doc)],
                    });
                    return [4 /*yield*/, remoteDb.remove({ _id: doc._id, _rev: doc._rev })];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, db.sync(remoteDb)];
                case 8:
                    _a.sent();
                    expect(lastAction()).toMatchObject({
                        type: sync.REMOVE_BULK_MODELS,
                        meta: { kind: kind, fromSync: true },
                        payload: [{ _id: doc._id }],
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=index.spec.js.map