import { Reducer } from 'redux';
import { InsertBulkModels, InsertModel, LoadModels, ModelInitialized, RemoveBulkModels, RemoveModel, SyncModel, UpdateBulkModels, UpdateModel } from './index';
export declare type Action<T extends SyncModel> = ModelInitialized | LoadModels<T> | InsertBulkModels<T> | InsertModel<T> | UpdateBulkModels<T> | UpdateModel<T> | RemoveBulkModels | RemoveModel;
export interface ReducerState<T> {
    models: T[];
    initialized: boolean;
}
export declare function createReducer<T extends SyncModel>(kind: string): Reducer<ReducerState<T>>;
