"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var actions = require("./actions");
var constants_1 = require("./constants");
var changeCallback = function (api, knownIDs, modelsToSync) { return function (result) {
    if (result.direction === 'push') {
        return;
    }
    var models = {};
    result.change.docs.forEach(function (doc) {
        if (actions.isDeletedDoc(doc) && knownIDs[doc._id] !== undefined) {
            var kind_1 = knownIDs[doc._id];
            if (models[kind_1] === undefined) {
                models[kind_1] = { insert: [], update: [], remove: [] };
            }
            models[kind_1].remove.push(doc);
            // api.dispatch(removeModel(doc, knownIDs[doc._id], true));
            delete knownIDs[doc._id];
            return;
        }
        if (!actions.isModelToSync(doc, modelsToSync)) {
            return;
        }
        var kind = doc.kind;
        if (models[kind] === undefined) {
            models[kind] = { insert: [], update: [], remove: [] };
        }
        if (knownIDs[doc._id] === undefined) {
            models[kind].insert.push(doc);
            knownIDs[doc._id] = doc.kind;
        }
        else {
            models[kind].update.push(doc);
        }
    });
    Object.keys(models).forEach(function (kind) {
        if (models[kind].insert.length > 0) {
            api.dispatch(actions.insertBulkModels(models[kind].insert, kind, true));
        }
        if (models[kind].update.length > 0) {
            api.dispatch(actions.updateBulkModels(models[kind].update, kind, true));
        }
        if (models[kind].remove.length > 0) {
            api.dispatch(actions.removeBulkModels(models[kind].remove, kind, true));
        }
    });
}; };
var fetchDocuments = function (db, api, knownIDs, modelsToSync, name, done) { return __awaiter(_this, void 0, void 0, function () {
    var response, docs, models;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, db.allDocs({ include_docs: true })];
            case 1:
                response = _a.sent();
                docs = response.rows.map(function (row) { return row.doc; });
                models = {};
                docs.forEach(function (doc) {
                    if (!actions.isModelToSync(doc, modelsToSync)) {
                        return;
                    }
                    if (models[doc.kind] === undefined) {
                        models[doc.kind] = [];
                    }
                    models[doc.kind].push(doc);
                    knownIDs[doc._id] = doc.kind;
                });
                Object.keys(models).forEach(function (kind) {
                    api.dispatch(actions.loadModels(models[kind], kind));
                    api.dispatch(actions.modelInitialized(kind));
                });
                api.dispatch(actions.initialized(name));
                if (done !== undefined) {
                    done();
                }
                return [2 /*return*/];
        }
    });
}); };
function updateModifiedAt(model) {
    var doc = model.toJSON !== undefined ? model.toJSON() : model;
    doc.updateAt = new Date();
    return doc;
}
var insertDocument = function (db, knownIDs, action) { return __awaiter(_this, void 0, void 0, function () {
    var doc;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, db.put(updateModifiedAt(action.payload))];
            case 1:
                _a.sent();
                return [4 /*yield*/, db.get(action.payload._id)];
            case 2:
                doc = _a.sent();
                if (!actions.isModel(doc)) {
                    return [2 /*return*/, action];
                }
                knownIDs[action.payload._id] = action.payload.kind;
                action.payload = doc;
                return [2 /*return*/, action];
        }
    });
}); };
function isBulkGetOK(doc) {
    return 'ok' in doc && actions.isModel(doc);
}
var insertBulkDocuments = function (db, knownIDs, action) { return __awaiter(_this, void 0, void 0, function () {
    var data, ids, resp, docs, models;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                data = action.payload.map(updateModifiedAt);
                return [4 /*yield*/, db.bulkDocs(data)];
            case 1:
                _a.sent();
                ids = data.map(function (d) {
                    return { id: d._id, rev: '' };
                });
                return [4 /*yield*/, db.bulkGet({ docs: ids })];
            case 2:
                resp = _a.sent();
                docs = resp.results.docs.filter(function (d) { return actions.isModel(d); });
                models = [];
                docs.forEach(function (d) {
                    if (!isBulkGetOK(d)) {
                        return;
                    }
                    knownIDs[d.ok._id] = d.ok.kind;
                    models.push(d.ok);
                });
                action.payload = models;
                return [2 /*return*/, action];
        }
    });
}); };
var updateDocument = function (db, action) { return __awaiter(_this, void 0, void 0, function () {
    var doc;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, db.put(updateModifiedAt(action.payload))];
            case 1:
                _a.sent();
                return [4 /*yield*/, db.get(action.payload._id)];
            case 2:
                doc = _a.sent();
                if (!actions.isModel(doc)) {
                    return [2 /*return*/, action];
                }
                action.payload = doc;
                return [2 /*return*/, action];
        }
    });
}); };
var updateBulkDocuments = function (db, knownIDs, action) { return __awaiter(_this, void 0, void 0, function () {
    var data, ids, resp, docs, models;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                data = action.payload.map(updateModifiedAt);
                return [4 /*yield*/, db.bulkDocs(data)];
            case 1:
                _a.sent();
                ids = data.map(function (d) {
                    return { id: d._id, rev: '' };
                });
                return [4 /*yield*/, db.bulkGet({ docs: ids })];
            case 2:
                resp = _a.sent();
                docs = resp.results.docs.filter(function (d) { return actions.isModel(d); });
                models = [];
                docs.forEach(function (d) {
                    if (!isBulkGetOK(d)) {
                        return;
                    }
                    knownIDs[d.ok._id] = d.ok.kind;
                    models.push(d.ok);
                });
                action.payload = models;
                return [2 /*return*/, action];
        }
    });
}); };
var removeDocument = function (db, knownIDs, action) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, db.remove(action.payload)];
            case 1:
                _a.sent();
                delete knownIDs[action.payload._id];
                return [2 /*return*/, action];
        }
    });
}); };
var removeBulkDocuments = function (db, knownIDs, action) { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, Promise.all(action.payload.map(function (d) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/, db.remove(d)];
                }); }); }))];
            case 1:
                _a.sent();
                action.payload.map(function (d) {
                    delete knownIDs[d._id];
                });
                return [2 /*return*/, action];
        }
    });
}); };
// tslint:disable max-func-body-length
function sync(db, replication, modelsToSync, name, done) {
    var knownIDs = {};
    return function (api) {
        return function (next) {
            if (replication !== undefined) {
                replication.on('change', changeCallback(api, knownIDs, modelsToSync));
            }
            fetchDocuments(db, api, knownIDs, modelsToSync, name, done).catch(function (err) {
                api.dispatch(actions.modelError(err, constants_1.OPERATION_FETCH_DOCS));
                if (done !== undefined) {
                    done();
                }
            });
            return function (action) {
                if (actions.isFromSync(action) ||
                    !actions.isAction(action) ||
                    !actions.hasMeta(action) ||
                    !actions.isModelToSync(action.meta, modelsToSync)) {
                    next(action);
                    return;
                }
                if (actions.isInsertAction(action)) {
                    insertDocument(db, knownIDs, action).then(next).catch(function (err) {
                        api.dispatch(actions.modelError(err, constants_1.OPERATION_INSERT));
                    });
                    return;
                }
                if (actions.isBulkInsertAction(action)) {
                    insertBulkDocuments(db, knownIDs, action).then(next).catch(function (err) {
                        api.dispatch(actions.modelError(err, constants_1.OPERATION_BULK_INSERT));
                    });
                    return;
                }
                if (actions.isUpdateAction(action)) {
                    updateDocument(db, action).then(next).catch(function (err) {
                        api.dispatch(actions.modelError(err, constants_1.OPERATION_UPDATE));
                    });
                    return;
                }
                if (actions.isBulkUpdateAction(action)) {
                    updateBulkDocuments(db, knownIDs, action).then(next).catch(function (err) {
                        api.dispatch(actions.modelError(err, constants_1.OPERATION_BULK_UPDATE));
                    });
                    return;
                }
                if (actions.isRemoveAction(action)) {
                    removeDocument(db, knownIDs, action).then(next).catch(function (err) {
                        api.dispatch(actions.modelError(err, constants_1.OPERATION_REMOVE));
                    });
                    return;
                }
                if (actions.isBulkRemoveAction(action)) {
                    removeBulkDocuments(db, knownIDs, action).then(next).catch(function (err) {
                        api.dispatch(actions.modelError(err, constants_1.OPERATION_BULK_REMOVE));
                    });
                    return;
                }
                // tslint:disable-next-line no-any
                next(action);
            };
        };
    };
}
exports.sync = sync;
// tslint:enable max-func-body-length
//# sourceMappingURL=sync.js.map